﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

public partial class _Default : System.Web.UI.Page
{
    //creation of ReadOnlyCollection
    static ReadOnlyCollection<string> ReadOnlyMessenger;  

    /// <summary>
    /// Page load event
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        lblDisplay.Text = "";

        if (!IsPostBack)
        {
            List<string> MessengerList = new List<string>();
            //add the items in List
            MessengerList.Add("GTalk");
            MessengerList.Add("Yahoo Messenger");
            MessengerList.Add("MSN Messenger");
            MessengerList.Add("Facebook Messenger");
            MessengerList.Add("AOL Messenger");

            ReadOnlyMessenger = new ReadOnlyCollection<string>(MessengerList);

            lstReadOnlyCollection.Items.Clear();
            foreach (string str in ReadOnlyMessenger)
            {
                lstReadOnlyCollection.Items.Add(str);
            }
       
        }        
    }

    /// <summary>
    /// Other common methods of ReadOnlyCollection
    /// </summary>
    private void OtherFunctionality()
    {
        lblDisplay.Text = " Count of All the Items of ReadOnlyCollection: " + ReadOnlyMessenger.Count;              

    }

    /// <summary>
    /// ReadOnlyCollection search
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        if (txtReadOnlyCollection.Text.Trim() != "")
        {
            if (ReadOnlyMessenger.Contains(txtReadOnlyCollection.Text.Trim()))
            {
                lblDisplay.Text = "ReadOnlyCollection Item Found";
            }
            else
            {
                lblDisplay.Text = "ReadOnlyCollection Item Not Found.";
            }
        }
        else
        {
            lblDisplay.Text = "ReadOnlyCollection - Please Enter an Item to Search";
        }
        
    }
  
   /// <summary>
  /// ReadOnlyCollection - Looping
  /// </summary>
  /// <param name="sender"></param>
  /// <param name="e"></param>
    protected void btnLooping_Click(object sender, EventArgs e)
    {
        // Loop through ReadOnlyCollection.
        foreach (string MessengerItems in ReadOnlyMessenger)
        {
            lblDisplay.Text += "," + MessengerItems;
        }

        lblDisplay.Text = lblDisplay.Text.TrimStart(',');
    }

    /// <summary>
    /// ReadOnlyCollection - Copyto
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnCopyTo_Click(object sender, EventArgs e)
    {
        string[] strArray = new string[ReadOnlyMessenger.Count+2];
        ReadOnlyMessenger.CopyTo(strArray, 1);

        foreach (string ArrayItems in strArray)
        {
            lblDisplay.Text += "," + ArrayItems;
        }

        lblDisplay.Text = lblDisplay.Text.TrimStart(',');

    }

    /// <summary>
    /// ReadOnlyCollection - IndexOf
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnIndex_Click(object sender, EventArgs e)
    {
        if (txtReadOnlyCollection.Text.Trim() != "")
        {
            int intIndex = ReadOnlyMessenger.IndexOf(txtReadOnlyCollection.Text.Trim());
            if (intIndex > -1)
            {
                lblDisplay.Text = "ReadOnlyCollection Item Found - " + intIndex;
            }
            else
            {
                lblDisplay.Text = "ReadOnlyCollection Item Not Found.";
            }
        }
        else
        {
            lblDisplay.Text = "ReadOnlyCollection - Please Enter an Item to Search";
        }
    }
}
